<?php
/***************************************************************************
*                                                                          *
*   (c) 2004 Vladimir V. Kalynyak, Alexey V. Vinokurov, Ilya M. Shalnev    *
*                                                                          *
* This  is  commercial  software,  only  users  who have purchased a valid *
* license  and  accept  to the terms of the  License Agreement can install *
* and use this program.                                                    *
*                                                                          *
****************************************************************************
* PLEASE READ THE FULL TEXT  OF THE SOFTWARE  LICENSE   AGREEMENT  IN  THE *
* "copyright.txt" FILE PROVIDED WITH THIS DISTRIBUTION PACKAGE.            *
****************************************************************************/

use Tygh\Http;
use Tygh\Registry;

if (!defined('BOOTSTRAP')) { die('Access denied'); }

function sign($base, $private_key) {
  return hash_hmac("sha256", $base, $private_key);
}

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    if ($mode == 'quickpay_ipn') {
        
        $request_body = file_get_contents("php://input");
        $return_data = json_decode($request_body, true);
        $order_id = str_replace('OrderID ', '', $return_data['order_id']);
        $order_info = fn_get_order_info($order_id);
        $private_key = $order_info['payment_method']['processor_params']['private_key'];
         
        //file_put_contents('_order_info_callback.txt', print_r($order_info,true));
        $checksum     = sign($request_body, $private_key);

        $order_info = fn_get_order_info($order_id);
        
        $cc_responce = array();
        foreach ($return_data['operations'] as $operation) {
            if ($operation['type'] == 'authorize') {
                $cc_responce['qp_status_msg'] = $operation['qp_status_msg'];
                $cc_responce['qp_status_code'] = $operation['qp_status_code'];
                $cc_responce['aq_status_msg'] = $operation['aq_status_msg'];
                $cc_responce['aq_status_code'] = $operation['aq_status_code'];
                $type = $operation['type'];
            }
        }

        $cc_responce['acquirer'] = $return_data['acquirer'];
        $cc_responce['type']  = (empty($return_data['metadata']['type'])) ? '' : $return_data['metadata']['type'];
        $cc_responce['brand'] = (empty($return_data['metadata']['brand'])) ? '' : $return_data['metadata']['brand'];
        $cc_responce['last4'] = (empty($return_data['metadata']['last4'])) ? '' : $return_data['metadata']['last4'];
        $cc_responce['country']  = (empty($return_data['metadata']['type'])) ? '' : $return_data['metadata']['country'];

        if ($return_data['test_mode'] == 1) {
            $cc_responce['test_mode'] = 'Y';
        }

        if ($checksum == $_SERVER["HTTP_QUICKPAY_CHECKSUM_SHA256"]) {
          // Request is authenticated
            
            if ($order_id && $type == 'authorize') {
                fn_change_order_status($order_id, 'P');
                fn_update_order_payment_info($order_id, $cc_responce);
                if (fn_allowed_for('MULTIVENDOR')) {
                    $child_order_ids = db_get_fields("SELECT order_id FROM ?:orders WHERE parent_order_id = ?i", $order_id);
                    if (!empty($child_order_ids)) {
                        foreach ($child_order_ids as $child_order_id) {
                            fn_change_order_status($order_id, 'P');
                            fn_update_order_payment_info($child_order_id, $cc_responce);
                        }
                    }
                }
            }
            else {
                fn_change_order_status($order_id, STATUS_INCOMPLETED_ORDER);
                fn_update_order_payment_info($order_id, $cc_responce);
                if (fn_allowed_for('MULTIVENDOR')) {
                    $child_order_ids = db_get_fields("SELECT order_id FROM ?:orders WHERE parent_order_id = ?i", $order_id);
                    if (!empty($child_order_ids)) {
                        foreach ($child_order_ids as $child_order_id) {
                            fn_change_order_status($order_id, STATUS_INCOMPLETED_ORDER);
                            fn_update_order_payment_info($child_order_id, $cc_responce);
                        }
                    }
                }
            }
            
            //file_put_contents('_quickpay_callback_1.txt', print_r($_SERVER,true));
        } else {
            fn_change_order_status($order_id, STATUS_INCOMPLETED_ORDER);
            fn_update_order_payment_info($order_id, $cc_responce);
            if (fn_allowed_for('MULTIVENDOR')) {
                $child_order_ids = db_get_fields("SELECT order_id FROM ?:orders WHERE parent_order_id = ?i", $order_id);
                if (!empty($child_order_ids)) {
                    foreach ($child_order_ids as $child_order_id) {
                        fn_change_order_status($order_id, STATUS_INCOMPLETED_ORDER);
                        fn_update_order_payment_info($child_order_id, $cc_responce);
                    }
                }
            }
        }
        //file_put_contents('_quickpay_callback.txt', print_r($_SERVER,true));
        //file_put_contents('_request_body.txt', print_r($return_data,true));
        
        exit;
    }
}